/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/

package lsagpi;
import java.awt.Color;
import java.awt.Image;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import java.awt.Font;

/**
 * Clase que parsea el panel de conversación.
 * @author Miguel Angel Pescador Santirso
 */
public class PanelConversacion {
    int TAMANO;
    int[] tinta=new int[3];
    int[] papel=new int[3];
    Font fuente;
    Vector opciones=new Vector(4);
    int opcionseleccionada=0;
    /**
    * Constructor del PanelConversacion.
    * @param descripcion Descripcion del Panel de Conversacion.
    */
    public PanelConversacion(String descripcion){
        
        StringTokenizer st = new StringTokenizer(descripcion,"\n",true);
        //nombre=st.nextToken();
        while (st.hasMoreTokens())
		{
            String cadena=st.nextToken();
            if(cadena.indexOf("TINTA")!=-1){
                System.out.println("Una tinta");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("TINTA"));
                    if(num.equals("{")){

                        tinta[0]=Integer.parseInt(num_tok.nextToken());
                        tinta[1]=Integer.parseInt(num_tok.nextToken());
                        tinta[2]=Integer.parseInt(num_tok.nextToken());
                    }

                }
                System.out.println("Tinta :"+tinta[0]+":"+tinta[1]+":"+tinta[2]);
            }
            if(cadena.indexOf("TAMAÑO")!=-1){
                System.out.println("Tamaño");
                StringTokenizer icon_tok=new StringTokenizer(cadena,"{");
                while(icon_tok.hasMoreTokens()){
                    if(icon_tok.nextToken().indexOf("TAMAÑO")>-1){
                        String color=icon_tok.nextToken();
                       TAMANO=Integer.parseInt(color.substring(0,color.indexOf("}")-1).trim());
                    }

                }
                System.out.println("Tamaño: "+TAMANO);
            }
            if(cadena.indexOf("PAPEL")!=-1){
                System.out.println("Un papel");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("PAPEL"));
                    if(num.equals("{")){

                        papel[0]=Integer.parseInt(num_tok.nextToken());
                        papel[1]=Integer.parseInt(num_tok.nextToken());
                        papel[2]=Integer.parseInt(num_tok.nextToken());
                    }

                }
                System.out.println("Papel :"+papel[0]+":"+papel[1]+":"+papel[2]);
            }
            if(cadena.indexOf("FUENTE")!=-1){
                System.out.println("Una fuente");
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                String num=new String("");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("FUENTE"));
                    if(num.equals("{")){
                        String nombre=num_tok.nextToken().trim();
                        nombre=nombre.substring(1,nombre.length()-1);
                        String tamano=num_tok.nextToken().trim();
                        int tam=Integer.parseInt(tamano);
                        fuente=new Font(nombre,Font.BOLD+Font.ITALIC,tam);
                    }

                }
            }

            }

    }
    /**
     * Añade una respuesta al panel de conversacion.
     * @param texto Texto de la respuesta.
     * @param numero Numero de la respuesta.
     */
    public void addRespuesta(String texto, int numero){
        if ((opciones.size()-1)<numero){
            opciones.add(texto);
        }else{
            opciones.add(numero-1, texto);
        }
    }
    /**
     * Limpia el panel de conversacion.
     */
    public void limpiarPanel(){
        opciones.add(0, " ");
        opciones.add(1, " ");
        opciones.add(2, " ");
        opciones.add(3, " ");
        //opciones.clear();
    }
    /**
     * Devuelve el color de la Tinta del Panel
     * @return Color de la Tinta (Foreground).
     */
    public Color getTinta(){
        return new Color(tinta[0],tinta[1], tinta[2]);
    }
    /**
     * Devuelve el color del Papel del Panel
     * @return Color del Papel (Background).
     */
     public Color getPapel(){
        return new Color(papel[0],papel[1], papel[2]);
    }
    /**
     * Selecciona la opcion elegida.
     * @param opcion Número con la opcion.
     */
    public void seleccionaOpcion(int opcion){
        opcionseleccionada=opcion;
        notify();
    }
    /**
     * Devuelve la opcion elegida, si no se ha elegido devuelve 0.
     * @return Opcion.
     */
    public int getOpcion(){
        return opcionseleccionada;
    }
}
